/*
  １回のデータ取得

  \author Satofumi Kamimura
*/

#include <memory>
#include <iostream>
#include "Lidar.h"
#include "open_lidar_device.h"
#include "log_printf.h"

using namespace hrk;
using namespace std;


int main(int argc, char *argv[])
{
    auto_ptr<Lidar> lidar(open_lidar_device(argc, argv));
    if (!lidar->is_open()) {
        cerr << FILE_POSITION() << lidar->what() << endl;
        return 1;
    }

    // 計測開始
    if (!lidar->start_measurement(Lidar::Distance, 1)) {
        cerr << FILE_POSITION() << lidar->what() << endl;
        return 1;
    }

    vector<long> data;
    long timestamp;
    if (!lidar->get_distance(data, &timestamp)) {
        cerr << FILE_POSITION() << lidar->what() << endl;
        return 1;
    }

    // 計測したデータの表示
    size_t n = data.size();
    cout << "n = " << n << endl;
    cout << "timestamp = " << timestamp << endl;

    for (size_t i = 0; i < n; ++i) {
        cout << data[i] << ", ";
    }
    cout << endl;

    return 0;
}
