﻿#ifndef HRK_POINT_F_H
#define HRK_POINT_F_H

/*!
  \file
  \brief 位置

  \author Satofumi Kamimura
*/

namespace hrk
{
    //! 位置
    class PointF
    {
    public:
        PointF(void);

        //! 初期値を指定するときのコンストラクタ
        PointF(double x, double y);

        //! x の値を返す
        double x(void) const;

        //! y の値を返す
        double y(void) const;

        //! x の値を登録する
        void set_x(double x);

        //! y の値を登録する
        void set_y(double y);

        //! operator
        bool operator == (const PointF& rhs) const;

        //! operator
        bool operator < (const PointF& rhs) const;

        //! operator
        PointF& operator += (const PointF& rhs);

        //! operator
        const PointF operator + (const PointF& rhs) const;

        //! operator
        PointF& operator -= (const PointF& rhs);

        //! operator
        const PointF operator - (const PointF& rhs) const;

        //! operator
        PointF& operator *= (const double rhs);

        //! operator
        const PointF operator * (const double rhs);

    private:
        double x_;
        double y_;
    };
}

#endif
