﻿#ifndef HRK_SIZE_F_H
#define HRK_SIZE_F_H

/*!
  \file
  \brief 幅と高さの管理

  \author Satofumi Kamimura
*/

namespace hrk
{
    //! 幅と高さ
    class SizeF
    {
    public:
        SizeF(void);
        SizeF(double width, double height);

        double width(void) const;
        double height(void) const;

        //! width の値を登録する
        void set_width(double width);

        //! height の値を登録する
        void set_height(double height);

        SizeF& operator += (const SizeF& rhs);
        const SizeF operator + (const SizeF& rhs) const;
        SizeF& operator -= (const SizeF& rhs);
        const SizeF operator - (const SizeF& rhs) const;

        SizeF& operator *= (double rhs);
        SizeF operator * (double rhs);

    private:
        double width_;
        double height_;
    };
}

#endif
