﻿#ifndef HRK_LOG_PRINTF_H
#define HRK_LOG_PRINTF_H

/*!
  \file
  \brief ログ出力

  \author Satofumi Kamimura
*/

#include <string>


namespace hrk
{
#define FILE_POSITION() LOG_PRINTF_FILE_LINE(__FILE__, __LINE__)
#define LOG_PRINTF_FILE_LINE(file, line) file ":" LOG_PRINTF_VALUE(line) ": "
#define LOG_PRINTF_VALUE(value) #value
#define ASSERT(a, b) assert(a && b)

    /*!
      \brief ログを出力するファイル名の指定

      \param[in] file_name 出力ファイル名。NULL を渡すとファイルが出力されない。
    */
    extern void log_set_file_name(const char* file_name);
    extern bool log_is_valid();

    //! ログファイルと stderr へのメッセージ出力
    extern int log_printf(const char* format, ...);
    extern int log_print(const char* text);

    extern size_t log_write(const char* buf, size_t count);

    extern void log_printf_close();
}

#endif
