﻿#ifndef HRK_TOKEN_UTILS_H
#define HRK_TOKEN_UTILS_H

/*!
  \file
  \brief トークンまわりの関数群

  \author Satofumi Kamimura
*/

#include <string>
#include <vector>
#include "SizeF.h"
#include "PointF.h"


namespace hrk
{
    extern std::string trim(const std::string& token);
    extern std::vector<std::string> split(const std::string& line,
                                          const char* separator = ",");
    extern std::string join(std::vector<std::string>& tokens,
                            const char* separator = "");
    extern void remove_empty_tokens(std::vector<std::string>& tokens);

    // wxh
    SizeF decode_size(const std::string& size_line);

    // +x+y
    PointF decode_point(const std::string& point_line);
}

#endif
